
package de.ivu.elect.presentation.gruppe.table;

import static org.apache.commons.lang3.StringUtils.trimToEmpty;

import de.ivu.elect.business.ergebnis.entity.Ergebnisart;
import de.ivu.elect.business.gruppe.entity.GruppeKumulierteStimmen;
import de.ivu.elect.jee.faces.Messages;

public class GruppeKumulierteStimmenAnzahlListenstimmenErgebnisartFuerDifferenzColumn extends AbstractGruppeKumulierteStimmenAnzahlColumn {

  private static final long serialVersionUID = 1L;

  private final Ergebnisart ergebnisartFuerDifferenz;

  public GruppeKumulierteStimmenAnzahlListenstimmenErgebnisartFuerDifferenzColumn(Messages messages, Ergebnisart ergebnisartFuerDifferenz) {
    super(messages);

    this.ergebnisartFuerDifferenz = ergebnisartFuerDifferenz;
  }

  @Override
  public String getHeader() {
    return formatHeader(getMessage(ergebnisartFuerDifferenz));
  }

  @Override
  public String getHeaderIgnoringErgebnisartFuerDifferenz() {
    return formatHeader(getMessage(HEADER_IGNORING_ERGEBNISART_FUER_DIFFERENZ_PLACEHOLDER_MSG_KEY));
  }

  private String formatHeader(Object... params) {
    return getMessage("gruppe.kumulierte.stimmen.anzahl.ergebnisart.fuer.differenz", params);
  }

  @Override
  public Object getValue(GruppeKumulierteStimmen gruppeKumulierteStimmen) {
    if (gruppeKumulierteStimmen.isHatListeInGebietshierarchie() || gruppeKumulierteStimmen.isAnzahlListenstimmenVorperiodeVorhanden()) {
      return gruppeKumulierteStimmen.getAnzahlListenstimmenVorperiode();
    }

    return null;
  }

  @Override
  public String getStyleClass() {
    return trimToEmpty(super.getStyleClass()) + " " + AbstractGruppeKumulierteStimmenColumn.DIFFERENZ_COLUMN_STYLE_CLASS;
  }
}
